// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <ClanLib/clanlayer2.h>

#include "mouse.hh"
#include "pingu.hh"
#include "button_panel.hh"
#include "actions/pingu_actions.hh"

CL_ResourceManager* ButtonPanel::resource = 0;
CL_Surface* ButtonPanel::button_cap;
//CL_Surface* ButtonPanel::button_cap_pers;
CL_Font*    ButtonPanel::font;

ButtonPanel::ButtonPanel()
{
  need_redraw = true;
  pressed_button = 2;
  button.resize(8);
  
  button[0] = new Button(  0, 424, "Buttons/exploder", resource);
  button[1] = new Button( 38, 424, "Buttons/walker", resource);
  button[2] = new Button( 76, 424, "Buttons/bridger", resource);
  button[3] = new Button(114, 424, "Buttons/blocker", resource);
  button[4] = new Button(152, 424, "Buttons/floater", resource);
  button[5] = new Button(190, 424, "Buttons/empty", resource);
  button[6] = new Button(228, 424, "Buttons/empty", resource);
  button[7] = new Button(266, 424, "Buttons/empty", resource);
}

ButtonPanel::~ButtonPanel()
{
}

void
ButtonPanel::let_move() 
{
  for(int i=0; i < button.size(); ++i) {
    button[i]->let_move();
  }

  if (Mouse::get_y() > 424 && Mouse::is_pressed(0)) {
    cout << "Getting current button" << endl;
    
    for(int i=0; i < 8; ++i) {
      if (Mouse::get_x() >= i * 38 && Mouse::get_x() < ((i + 1) * 38)) {
	pressed_button = i;
	cout << pressed_button << " Button pressed" << endl;
	break;
      }
    }
  }
}

PinguAction*
ButtonPanel::get_action()
{
  // remmed because of the rewrite of pingu.cc
  //  cout << pressed_button << " Button checked" << endl;
  switch (pressed_button) {
  case 4:
    return new Floater;
  case 0:
    return new Bomber;
  case 1:
    //    return walker;
  case 2:
    //    return bridger;
  case 3:
    //    return blocker;
  default:
    return new Walker;
  }
}

void 
ButtonPanel::draw() 
{
  need_redraw = true;
  if (need_redraw) {
    // draw the buttons
    for(int i=0; i < button.size(); ++i) {
      button[i]->draw();
    }
    need_redraw = false;
  }

  // draw the capture rectangle for the active button
  button_cap->put_screen(pressed_button*38, 424);
  /*
  // draw the capture rectangle for the current button
  if (Mouse::get_y() > 424) {
    for(int i=0; i < 8; ++i) {
      if (Mouse::get_x() > i * 38 && Mouse::get_x() < ((i + 1) * 38)) {
	button_cap->put_screen(i*38, 424);
	need_redraw = true;
      }
    }
    }*/
}

void
ButtonPanel::load_data(CL_ResourceManager* res)
{
  resource = res;
  button_cap      = CL_Res_Surface::load("Buttons/button_cap", *resource);
  //  button_cap_pers = CL_Res_Surface::load("Buttons/button_capp", *resource);

  font            = CL_Res_Font::load("Fonts/font", *resource);
}

/* EOF */
